
function esercizio_quadratura

% esercizio sulle formule di quadratura

% definizione integranda
f=@(x) exp(-x.^2);
a=0; b=1;

% erf(x) = 2/sqrt(pi) * integral from 0 to x of exp(-t^2) dt.
sol=(sqrt(pi)/2)*erf(1);

for k=1:8
    N(k)=2^k;
    % trapezi composta
    [x,w]=trapezi_composta(N(k),a,b);
    S_T(k)=sum(w.*f(x));
    % Cavalieri-Simpson composta
    [x,w]=cavalieri_simpson_composta(N(k),a,b);
    S_CS(k)=sum(w.*f(x));
end

% valutazione errori assoluti
E_T=abs(sol-S_T);
E_CS=abs(sol-S_CS);

% plot errori
clf;
semilogy(N,E_T,'r-','LineWidth',2);
hold on;
semilogy(N,E_CS,'b-','LineWidth',2);
title('Esercizio quadratura');
legend('Trapezi','Cavalieri-Simpson');
hold off;